#include "op.h"

// Reference: https://www.nesdev.org/wiki/CPU_unofficial_opcodes

#define IS_OP_CODE_MODE(op, op_code, addr_mode) \
    case op_code: \
        op_ ## op(ADDR_MODE_ ## addr_mode); \
        break;

#define IS_OP_CODE(op, op_code) \
    IS_OP_CODE_MODE(op, op_code, IMPLICIT)

#define IS_ALU_OP_CODE_(op, offset, addr_mode) \
    IS_OP_CODE_MODE(op, OP_CODE_ ## op + offset, addr_mode)

#define IS_ALU_OP_CODE(op) \
    IS_ALU_OP_CODE_(op, 0x01, INDEXED_INDIRECT) \
    IS_ALU_OP_CODE_(op, 0x05, ZERO_PAGE) \
    IS_ALU_OP_CODE_(op, 0x09, IMMEDIATE) \
    IS_ALU_OP_CODE_(op, 0x0d, ABSOLUTE) \
    IS_ALU_OP_CODE_(op, 0x11, INDIRECT_INDEXED) \
    IS_ALU_OP_CODE_(op, 0x15, ZERO_PAGE_INDEXED_X) \
    IS_ALU_OP_CODE_(op, 0x19, ABSOLUTE_INDEXED_Y) \
    IS_ALU_OP_CODE_(op, 0x1d, ABSOLUTE_INDEXED_X)

#define IS_ALU_OP_CODE_NO_IMMEDIATE(op) \
    IS_ALU_OP_CODE_(op, 0x01, INDEXED_INDIRECT) \
    IS_ALU_OP_CODE_(op, 0x05, ZERO_PAGE) \
    IS_ALU_OP_CODE_(op, 0x0d, ABSOLUTE) \
    IS_ALU_OP_CODE_(op, 0x11, INDIRECT_INDEXED) \
    IS_ALU_OP_CODE_(op, 0x15, ZERO_PAGE_INDEXED_X) \
    IS_ALU_OP_CODE_(op, 0x19, ABSOLUTE_INDEXED_Y) \
    IS_ALU_OP_CODE_(op, 0x1d, ABSOLUTE_INDEXED_X)

void op_ORA(addr_mode_t addr_mode) {

}

void op_AND(addr_mode_t addr_mode) {

}

void op_EOR(addr_mode_t addr_mode) {

}

void op_ADC(addr_mode_t addr_mode) {

}

void op_STA(addr_mode_t addr_mode) {

}

void op_LDA(addr_mode_t addr_mode) {

}

void op_CMP(addr_mode_t addr_mode) {

}

void op_SBC(addr_mode_t addr_mode) {

}

void process_op_code(int op) {
    switch (op) {
        // CTRL
        IS_OP_CODE(BRK, 0x00)
        IS_OP_CODE_MODE(NOP, 0x04, ZERO_PAGE)

        // ALU
        IS_ALU_OP_CODE(ORA)
        IS_ALU_OP_CODE(AND)
        IS_ALU_OP_CODE(EOR)
        IS_ALU_OP_CODE(ADC)
        IS_ALU_OP_CODE_NO_IMMEDIATE(STA)
        IS_ALU_OP_CODE(LDA)
        IS_ALU_OP_CODE(CMP)
        IS_ALU_OP_CODE(SBC)
    }
}
